--- addon/vhdlscanner.l	2010-05-22 10:03:00.000000000 -0700
+++ src/vhdlscanner.l	2010-05-22 09:55:28.000000000 -0700
@@ -632,8 +632,8 @@
 PROCESS                 ({B}*{FUNCNAME}{B}*:{BR}*)?({B}*("postponed"){BR}+)?{B}*("process"){BR}*{PROTO}
 
 ENDPROCESS              ("end"){BR}*("postponed")*("process"){BR}*{FUNCNAME}*{BR}*[;]
-LIBUSE                  ^{B}*("use"|"library"){BR}+
-ENTITY                  ^{B}*("component"|"entity"|"package"){BR}+
+LIBUSE                 ("use"|"library"){BR}+
+ENTITY                  ("component"|"entity"|"package"){BR}+
 PBODY                   ("package"){B}+("body"){BR}+{NAME}
 SHARED                  ("shared"){BR}+("variable")
 SIGTYPES                ^{B}*({SHARED}|"alias"|"file"|"group"|"subtype"|"type"|"constant"|"attribute"|"signal"|"units"){BR}+
@@ -933,12 +933,20 @@
   BEGIN(ParseUnits);
 }
 
-<FindName>{NAME} {  // found entity|architecture|component name
-  lineCount();
+<FindName>{B}*{NAME}{BR}*[,]*{BR}* {  // found entity|architecture|component name
 
   QCString qcs(yytext);
+  
+//  fprintf(stderr,"\n [%s]",yytext);
+  bool bList=qcs.contains(',');
+  bool bLibUse=(current->spec==VhdlDocGen::USE || current->spec==VhdlDocGen::LIBRARY);
+  
+  if(bList)
+   VhdlDocGen::deleteAllChars(qcs,',');
+  int iSpec=current->spec;
   qcs=qcs.stripWhiteSpace();
-  if (current->spec==VhdlDocGen::USE || current->spec==VhdlDocGen::LIBRARY)
+  
+  if (bLibUse)
   {
     int j=qcs.length();
     int i=qcs.find(".");
@@ -963,6 +971,7 @@
     -- entity bbb;
     */
       
+    current->bodyLine=yyLineNr;
     current->name=qcs;                 
     Entry *copy=new Entry(*current);
     current->reset();
@@ -973,15 +982,15 @@
     //current->name+=qcs.lower();
     current->name.prepend(qcs+"::");
 
-    //if (lastEntity)
-    //{
+    if (lastEntity)
+    {
       // inherit private inheritance relation between entity and architecture
-      //if (!VhdlDocGen::foundInsertedComponent(current->name,lastEntity))
-      //{
-	//	BaseInfo *bb=new BaseInfo(current->name,Private,Normal);
-	//	lastEntity->extends->append(bb);    
-      //}
-    //}
+      if (!VhdlDocGen::foundInsertedComponent(current->name,lastEntity))
+      {
+	BaseInfo *bb=new BaseInfo(current->name,Private,Normal);
+	lastEntity->extends->append(bb);    
+      }
+    }
 
   }
   else if (current->spec==VhdlDocGen::PACKAGE_BODY)
@@ -995,6 +1004,25 @@
   if (!(current->spec==VhdlDocGen::USE || current->spec==VhdlDocGen::LIBRARY))
   newEntry();
 
+ lineCount();
+
+ 
+ if(bLibUse && bList)
+ {
+   current->spec=iSpec;
+   if(current->spec==VhdlDocGen::USE)
+   current->type="package";
+     else
+   current->type="library";
+   current->section=Entry::VARIABLE_SEC;
+    if(current->spec==VhdlDocGen::USE)
+     BEGIN(Start);
+      else
+     BEGIN(FindName);
+   //unput(',');
+  // BEGIN(sss);
+ }
+ else
   BEGIN(Start);
 }
 --- addon/vhdlcode.l	2010-05-22 10:02:42.000000000 -0700
+++ src/vhdlcode.l	2010-05-22 09:53:14.000000000 -0700
@@ -1153,8 +1153,8 @@
 <ParsePackage>[^:;]*    { //found package 
                           QCString temp(vhdlcodeYYtext);
                           QStringList strl=QStringList::split(".",temp,FALSE);
-                                
-                          if (strl.count()>2) 
+                           bool bList=temp.contains(',');
+                          if (strl.count()>2 && !bList) 
 			  {
                              QCString s1=(QCString)strl[0];  
                              QCString s2=(QCString)strl[1];  
@@ -1175,6 +1175,9 @@
                            }
                            else
 			   {
+                             if(bList)
+                              codifyLines(vhdlcodeYYtext);
+			                 else
                              writeFont("keywordflow",vhdlcodeYYtext);
 			   }
                            BEGIN(Bases);


